;--------------------------------------------------------------------------
;   N76E003.asm 20200509
;   Header file for Nuvoton N76E003 
;--------------------------------------------------------------------------

P0              .EQU    0x80
P00     .EQU    P0+0
P01     .EQU    P0+1
P02     .EQU    P0+2
P03     .EQU    P0+3
P04     .EQU    P0+4
P05     .EQU    P0+5
P06     .EQU    P0+6
P07     .EQU    P0+7
P0_0    .EQU    P0+0
P0_1    .EQU    P0+1
P0_2    .EQU    P0+2
P0_3    .EQU    P0+3
P0_4    .EQU    P0+4
P0_5    .EQU    P0+5
P0_6    .EQU    P0+6
P0_7    .EQU    P0+7

SP              .EQU    0x81

DPTR            .EQU    0x82
DPL             .EQU    0x82

DPH             .EQU    0x83

RCTRIM0         .EQU    0x84

RCTRIM1         .EQU    0x85

RWK             .EQU    0x86

PCON            .EQU    0x87

TCON            .EQU    0x88
IT0     .EQU    TCON+0
IE0     .EQU    TCON+1
IT1     .EQU    TCON+2
IE1     .EQU    TCON+3
TR0     .EQU    TCON+4
TF0     .EQU    TCON+5
TR1     .EQU    TCON+6
TF1     .EQU    TCON+7

TMOD            .EQU    0x89

TL0             .EQU    0x8A

TL1             .EQU    0x8B

TH0             .EQU    0x8C

TH1             .EQU    0x8D

CKCON           .EQU    0x8E

WKCON           .EQU    0x8F

P1              .EQU    0x90
P10     .EQU    P1+0
P11     .EQU    P1+1
P12     .EQU    P1+2
P13     .EQU    P1+3
P14     .EQU    P1+4
P15     .EQU    P1+5
P16     .EQU    P1+6
P17     .EQU    P1+7
P1_0    .EQU    P1+0
P1_1    .EQU    P1+1
P1_2    .EQU    P1+2
P1_3    .EQU    P1+3
P1_4    .EQU    P1+4
P1_5    .EQU    P1+5
P1_6    .EQU    P1+6
P1_7    .EQU    P1+7

SFRS            .EQU    0x91 ;TA Protection

CAPCON0         .EQU    0x92

CAPCON1         .EQU    0x93

CAPCON2         .EQU    0x94

CKDIV           .EQU    0x95

CKSWT           .EQU    0x96 ;TA Protection

CKEN            .EQU    0x97 ;TA Protection

SCON            .EQU    0x98
RI      .EQU    SCON+0
TI      .EQU    SCON+1
RB8     .EQU    SCON+2
TB8     .EQU    SCON+3
REN     .EQU    SCON+4
SM2     .EQU    SCON+5
SM1     .EQU    SCON+6
SM0     .EQU    SCON+7
FE      .EQU    SCON+7

SBUF            .EQU    0x99

SBUF_1          .EQU    0x9A

EIE             .EQU    0x9B

EIE1            .EQU    0x9C

CHPCON          .EQU    0x9F ;TA Protection

P2              .EQU    0xA0
P20     .EQU    P2+0
P2_0    .EQU    P2+0

AUXR1           .EQU    0xA2

BODCON0         .EQU    0xA3 ;TA Protection

IAPTRG          .EQU    0xA4 ;TA Protection

IAPUEN          .EQU    0xA5 ;TA Protection

IAPAL           .EQU    0xA6

IAPAH           .EQU    0xA7

IE              .EQU    0xA8
EX0     .EQU    IE+0
ET0     .EQU    IE+1
EX1     .EQU    IE+2
ET1     .EQU    IE+3
ES      .EQU    IE+4
EBOD    .EQU    IE+5
EADC    .EQU    IE+6
EA      .EQU    IE+7

SADDR           .EQU    0xA9

WDCON           .EQU    0xAA ;TA Protection

BODCON1         .EQU    0xAB ;TA Protection

P3M1            .EQU    0xAC
P3S             .EQU    0xAC ;Page1

P3M2            .EQU    0xAD
P3SR            .EQU    0xAD ;Page1

IAPFD           .EQU    0xAE

IAPCN           .EQU    0xAF

P3              .EQU    0xB0
P30     .EQU    P3+0
P3_0    .EQU    P3+0

P0M1            .EQU    0xB1
P0S             .EQU    0xB1 ;Page1

P0M2            .EQU    0xB2
P0SR            .EQU    0xB2 ;Page1

P1M1            .EQU    0xB3
P1S             .EQU    0xB3 ;Page1

P1M2            .EQU    0xB4
P1SR            .EQU    0xB4 ;Page1

P2S             .EQU    0xB5

IPH             .EQU    0xB7
PWMINTC         .EQU    0xB7 ;Page1
;
IP              .EQU    0xB8
PX0     .EQU    IP+0
PT0     .EQU    IP+1
PX1     .EQU    IP+2
PT1     .EQU    IP+3
PS      .EQU    IP+4
PBOD    .EQU    IP+5
PADC    .EQU    IP+6

SADEN           .EQU    0xB9

SADEN_1         .EQU    0xBA

SADDR_1         .EQU    0xBB

I2DAT           .EQU    0xBC

I2STAT          .EQU    0xBD

I2CLK           .EQU    0xBE

I2TOC           .EQU    0xBF

I2CON           .EQU    0xC0
I2CPX   .EQU    I2CON+0
AA      .EQU    I2CON+2
SI      .EQU    I2CON+3
STO     .EQU    I2CON+4
STA     .EQU    I2CON+5
I2CEN   .EQU    I2CON+6

I2ADDR          .EQU    0xC1

ADCRL           .EQU    0xC2

ADCRH           .EQU    0xC3

T3CON           .EQU    0xC4
PWM4H           .EQU    0xC4 ;Page1

RL3             .EQU    0xC5
PWM5H           .EQU    0xC5 ;Page1

RH3             .EQU    0xC6
PIOCON1         .EQU    0xC6 ;Page1

TA              .EQU    0xC7
;
T2CON           .EQU    0xC8
CM_RL2  .EQU    T2CON+0
TR2     .EQU    T2CON+2
TF2     .EQU    T2CON+7

T2MOD           .EQU    0xC9

RCMP2L          .EQU    0xCA

RCMP2H          .EQU    0xCB

TL2             .EQU    0xCC
PWM4L           .EQU    0xCC ;Page1

TH2             .EQU    0xCD
PWM5L           .EQU    0xCD ;Page1

ADCMPL          .EQU    0xCE

ADCMPH          .EQU    0xCF

PSW             .EQU    0xD0
P       .EQU    PSW+0
OV      .EQU    PSW+2
RS0     .EQU    PSW+3
RS1     .EQU    PSW+4
F0      .EQU    PSW+5
AC      .EQU    PSW+6
CY      .EQU    PSW+7

PWMPH           .EQU    0xD1

PWM0H           .EQU    0xD2

PWM1H           .EQU    0xD3

PWM2H           .EQU    0xD4

PWM3H           .EQU    0xD5

PNP             .EQU    0xD6

FBD             .EQU    0xD7

PWMCON0         .EQU    0xD8
CLRPWM  .EQU    PWMCON0+4
PWMF    .EQU    PWMCON0+5
LOAD    .EQU    PWMCON0+6
PWMRUN  .EQU    PWMCON0+7

PWMPL           .EQU    0xD9

PWM0L           .EQU    0xDA

PWM1L           .EQU    0xDB

PWM2L           .EQU    0xDC

PWM3L           .EQU    0xDD

PIOCON0         .EQU    0xDE

PWMCON1         .EQU    0xDF


ACC             .EQU    0xE0
ACC0     .EQU    ACC+0
ACC1     .EQU    ACC+1
ACC2     .EQU    ACC+2
ACC3     .EQU    ACC+3
ACC4     .EQU    ACC+4
ACC5     .EQU    ACC+5
ACC6     .EQU    ACC+6
ACC7     .EQU    ACC+7
ACC_0    .EQU    ACC+0
ACC_1    .EQU    ACC+1
ACC_2    .EQU    ACC+2
ACC_3    .EQU    ACC+3
ACC_4    .EQU    ACC+4
ACC_5    .EQU    ACC+5
ACC_6    .EQU    ACC+6
ACC_7    .EQU    ACC+7

ADCCON1         .EQU    0xE1

ADCCON2         .EQU    0xE2

ADCDLY          .EQU    0xE3

C0L             .EQU    0xE4

C0H             .EQU    0xE5

C1L             .EQU    0xE6

C1H             .EQU    0xE7

ADCCON0         .EQU    0xE8
ADCHS0  .EQU    ADCCON0+0
ADCHS1  .EQU    ADCCON0+1
ADCHS2  .EQU    ADCCON0+2
ADCHS3  .EQU    ADCCON0+3
ETGSEL0 .EQU    ADCCON0+4
ETGSEL1 .EQU    ADCCON0+5
ADCS    .EQU    ADCCON0+6
ADCF    .EQU    ADCCON0+7

PICON           .EQU    0xE9

PINEN           .EQU    0xEA

PIPEN           .EQU    0xEB

PIF             .EQU    0xEC

C2L             .EQU    0xED

C2H             .EQU    0xEE

EIP             .EQU    0xEF

B               .EQU    0xF0
B0      .EQU    B+0
B1      .EQU    B+1
B2      .EQU    B+2
B3      .EQU    B+3
B4      .EQU    B+4
B5      .EQU    B+5
B6      .EQU    B+6
B7      .EQU    B+7
B_0     .EQU    B+0
B_1     .EQU    B+1
B_2     .EQU    B+2
B_3     .EQU    B+3
B_4     .EQU    B+4
B_5     .EQU    B+5
B_6     .EQU    B+6
B_7     .EQU    B+7

CAPCON3         .EQU    0xF1

CAPCON4         .EQU    0xF2

SPCR            .EQU    0xF3
SPCR2           .EQU    0xF3 ;Page1

SPSR            .EQU    0xF4

SPDR            .EQU    0xF5

AINDIDS         .EQU    0xF6

EIPH            .EQU    0xF7

SCON_1          .EQU    0xF8
RI_1    .EQU    SCON_1+0
TI_1    .EQU    SCON_1+1
RB8_1   .EQU    SCON_1+2
TB8_1   .EQU    SCON_1+3
REN_1   .EQU    SCON_1+4
SM2_1   .EQU    SCON_1+5
SM1_1   .EQU    SCON_1+6
SM0_1   .EQU    SCON_1+7
FE_1    .EQU    SCON_1+7

PDTEN           .EQU    0xF9 ;TA Protection

PDTCNT          .EQU    0xFA ;TA Protection

PMEN            .EQU    0xFB

PMD             .EQU    0xFC

PORDIS			.EQU	0xFD ;TA Protection

EIP1            .EQU    0xFE

EIPH1           .EQU    0xFF
