; main.asm LED Blink SN20200420 Demo main module in ASM for Nuvoton N76E003
; Use sdas8051.exe and sdcc.exe version 4.0.0 inside Eclipse with auto make.
;
; Use this template for ASM programming with SDAS in SDCC in Exlipse IDE.
; You probably must set or #define FOSC_160000 before it will compile!
;
; To assemble and link this file use Eclipse auto-make or invoke the following commands:
;	sdas8051.exe -losffgp filename.asm
;	sdcc.exe <options> filename.rel
; Defining custom area names in DATA or BIT will collide with similar hard-coded areas!
;-----------------------------------------------------------------------------------------------
; Included header files and libraries which are needed by this module go here.
.include "N76E003.asm"		; register and bit definition file for Nuvoton N76E003
;-----------------------------------------------------------------------------------------------
; The name of this module and command line compiler or linker options go here.
.module main				; the name of this module goes here but this is optional
;	.optsdcc -mmcs51 --model-small	; SDCC compiler emits this so may not be needed
;-----------------------------------------------------------------------------------------------
; Export .GLOBAL symbols to other modules or alternately define them in the code sections below.
;	.GLOBL symbol_name		; example global symbol exportation.
;-----------------------------------------------------------------------------------------------
; Document .GLOBL symbols imported form other modules or do this in the code sections below.
;	.GLOBL symbol_name		; example global symbol documentation
;-----------------------------------------------------------------------------------------------
; Dpecial function register and bit declarations go here if .include file was not used above.
;	symbol_name .EQU 0x9C	; example register or bit definition
;-----------------------------------------------------------------------------------------------
; Add constant aka typeless numbers here. These could be system configuration symbols etc.
;	symbol_name .EQU 0x00	; example definition
;-----------------------------------------------------------------------------------------------
.page						; force page break in listing, RAM areas continue below
;-----------------------------------------------------------------------------------------------
.AREA REG_BANK_0 (OVR,DATA) ; absolute overlayable space for register bank 0
	.DS		8
.AREA REG_BANK_1 (OVR,DATA) ; uncomment to reserve space for register bank 1
;	.DS		8
.AREA REG_BANK_2 (OVR,DATA) ; uncomment to reserve space for register bank 2
;	.DS		8
.AREA REG_BANK_3 (OVR,DATA) ; uncomment to reserve space for register bank 3
;	.DS		8
; the above fucntionality is hard coded so do not attempt to do anything else with it!
;-----------------------------------------------------------------------------------------------
.AREA RSEG (ABS,DATA)		; absolute global register space in DATA area 0x00 ~ 0x80
;	.ORG 0x10				; anchor to address of specific register or register set
;	symbol_name: .DS 8		; example register space reservation
;-----------------------------------------------------------------------------------------------
.AREA DSEG (DATA) 			; global space in DATA area 0x00 ~ 0x80
;	symbol_name: .DS 2		; example space reservation
;-----------------------------------------------------------------------------------------------
.AREA OSEG (OVR,DATA) 		; overlayable space in DATA area 0x00 ~ 0x80
;	symbol_name: .DS 2		; example space reservation
;-----------------------------------------------------------------------------------------------
.AREA SSEG (DATA)			; global MCU stack space in IDATA area 0x00 ~ 0xFF
__start__stack:: .DS 1		; all residual space will be assigned despite reserving only 1 byte
; Do not attempt to define any additional symbols since they will just be silently ignored.
;-----------------------------------------------------------------------------------------------
.AREA ISEG (DATA)			; global space in IDATA area 0x00 ~ 0xFF
;	symbol_name: .DS 3		; example space reservation
;-----------------------------------------------------------------------------------------------
.AREA IABS (ABS,DATA)		; absolute global space in IDATA area 0x00 ~ 0xFF
;	.ORG 0xFE				; anchor to address of memory location or register
;	symbol_name: .DS 2		; example space reservation or register definition
;-----------------------------------------------------------------------------------------------
.AREA BSEG (BIT)			; global space in BIT area 0x00 ~ 0x7F shown in RAM layout as B
;	symbol_name: .DS 4		; example reserving 4 BITs which use up half a byte at DATA 0x20
; Corresponding DATA area range 0x20 ~ 0x2F is automatically reserved as bits are allocated.
; The ABS directive does not function in BIT areas so the reservation is just silently dropped!
; A possible workaround is to allocate the corresponding byte in DATA area range 0x20 ~ 0x2F.
;-----------------------------------------------------------------------------------------------
.AREA BSEG_BYTES (DATA)		; global bit adressable space in DATA area 0x20 ~ 0x2F shown as B
;	symbol_name: .DS 1		; example reserving 1 byte allocation containing 8 bit allocations
; Corresponding BIT area range 0x00 ~ 0x7F is automatically reserved as bytes are allocated.
;-----------------------------------------------------------------------------------------------
.AREA BIT_BANK (OVR,DATA)	; global bit adressable space in DATA area 0x20 ~ 0x2F shown as T
;	symbol_name: .DS 1		; example reserving 1 byte allocation containing 8 bit allocations
; These allocations are not associated with BSEG (BIT) or BSEG_BYTES (DATA) but are useful for
; re-entrant functions needing bit parameters or variables which are easy to push and pop.
;-----------------------------------------------------------------------------------------------
.AREA PSEG (PAG,XDATA)		; global space in PDATA inpage area 0x??00 ~ 0x??FF
;	symbol_name: .DS 160	; example space reservation with 256 byte page allignment
; The ABS directive does not function within PDATA inpage so allignment errors are returned!
;-----------------------------------------------------------------------------------------------
.AREA XSEG (XDATA)			; global space in XDATA area 0x0000 ~ 0xFFFF
;	symbol_name: .DS 384	; example space reservation
; If XDATA does not start at 0x0000 then customize it using linker flag: --xram-loc 0x????
;-----------------------------------------------------------------------------------------------
.AREA XABS (ABS,XDATA)		; absolute global space in XDATA area 0x0000 ~ 0xFFFF
;	.ORG 0xD000				; anchor to address of memory location or I/O port
;	symbol_name: .DS 1		; example space reservation or port definition
;-----------------------------------------------------------------------------------------------
	.AREA XISEG (XDATA)		; global space in initialized XDATA area 0x0000 ~ 0xFFFF
;	symbol_name: .DS 300		; example space reservation
; Use this with NVRAM or if initialization code copies values from CODE to XDATA at startup.
;-----------------------------------------------------------------------------------------------
.page						; force page break in listing, ROM code areas continue below
;-----------------------------------------------------------------------------------------------
.AREA HOME (ABS,CODE) ; for reset and interrupt vectors at 0x0000 as defined in hardware
.ORG 0x0000					; reset vector should only be defined in main
			ljmp	_gsinit ; jump to initialization
;	.ORG 0x0003				; external interrupt 0
;	.ORG 0x000B				; timer 0 overflow
;	.ORG 0x0013				; external interrupt 1
;	.ORG 0x001B				; timer 1 overflow
;	.ORG 0x0023				; serial port 0 interrupt
;	.ORG 0x002B				; timer 2 event
;	.ORG 0x0033				; I2C status/timer-out interrupt
;	.ORG 0x003B				; pin interrupt
;	.ORG 0x0043				; brown-out detection interrupt
;	.ORG 0x004B				; SPI interrupt
;	.ORG 0x0053				; WDT interrupt
;	.ORG 0x005B				; ADC interrupt
;	.ORG 0x0063				; input capture interrupt
;	.ORG 0x006B				; PWM interrupt
;	.ORG 0x0073				; fault brake interrupt
;	.ORG 0x007B				; serial port 1 interrupt
;	.ORG 0x0083				; timer 3 overflow
;	.ORG 0x008B				; self wake-up timer interrupt
;-----------------------------------------------------------------------------------------------
.AREA GSINIT (CODE) ; Global & Static INITialisation routines can go here
_gsinit::
; disable POR as recommended by Nuvoton
			mov 0xC7,#0xAA
			mov 0xC7,#0x55
			mov 0xFD,#0x5A
			mov 0xC7,#0xAA
			mov 0xC7,#0x55
			mov 0xFD,#0xA5
; initialize hardware stack pointer SP if specified size is non-zero
   			mov sp,#__start__stack - 1
; initialization for our main program including subroutines and ISRs is directly below
			anl		P1M1,#0xEF	; P04_Quasi_Mode to drive debug LED
			anl		P1M2,#0xEF
; no ljump is needed here so long as external module and library CSEG names are unique
			ljmp _main
;-----------------------------------------------------------------------------------------------
.AREA CSEG (CODE) ; our example main program including subroutines and ISRs is directly below
_main:: ; Our main program loop to flash the LED is directly below since we initialized earlier.
	loop:		setb	P14			; turn LED off
				mov	dptr,#50		; call 500ms timer delay function
				clr	a
				mov	b,a
				lcall	_Timer1_Delay10ms
				clr		P14			; turn LED on
				mov	dpl,#250		; call 250ms timer delay function
				lcall	_delay1ms
				sjmp	loop

_delay1ms: ; Our software time delay subroutine which trashes the contents of PSW, R0, R1 and R2.
				mov R2,dpl			; loop count was passed via dpl
	label1:		mov R1,#0x08		; 8 x 12.5ms produces 1ms total
	label2:		mov R0,#0xfa		; FA is 12.5ms (or C7 is 100us)
	label3:		djnz R0,label3
				djnz R1,label2
				djnz R2,label1
				ret
;-----------------------------------------------------------------------------------------------
.AREA CONST (CODE)				; space for CONSTants that need to be in ROM go here
;	symbol_name: .strz "Hi\n"	; example byte data elements in ROM
;-----------------------------------------------------------------------------------------------
.AREA XINIT (CODE)				; source ROM data for XISEG INITialization
;	symbol_name: .DB 0x82,0x90	; example byte data elements in ROM
;-----------------------------------------------------------------------------------------------
.AREA CABS (ABS,CODE)			; Code ABSolute may be an input port or contain ROM data
;	.ORG 0xC000					; anchor to address of input port or ROM data
;	symbol_name: .DS 1			; example input port definition
;	symbol_name: .DB 0x67,0x55	; example byte data elements in ROM
;-----------------------------------------------------------------------------------------------
.page							; force page break in listing
;-----------------------------------------------------------------------------------------------
;END							; end of file marker
